# Copyright (c) 2011 The Chromium Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

# NOTE: this file is autogenerated by deps/third_party/ffmpeg/generate_gyp.py

{
  'conditions': [
    ['((target_arch == "arm" and arm_neon == 1)) and (ffmpeg_branding == "Chrome" or ffmpeg_branding == "ChromeOS")', {
      'sources': [
        'patched-ffmpeg/libavcodec/arm/h264dsp_neon.S',
        'patched-ffmpeg/libavcodec/arm/h264idct_neon.S',
      ],
    }],  # ((target_arch == "arm" and arm_neon == 1)) and (ffmpeg_branding == "Chrome" or ffmpeg_branding == "ChromeOS")
    ['(target_arch == "ia32" or target_arch == "x64") and (ffmpeg_branding == "Chrome" or ffmpeg_branding == "ChromeOS")', {
      'sources': [
        'patched-ffmpeg/libavcodec/x86/dct32_sse.asm',
        'patched-ffmpeg/libavcodec/x86/h264_deblock.asm',
        'patched-ffmpeg/libavcodec/x86/h264_deblock_10bit.asm',
        'patched-ffmpeg/libavcodec/x86/h264_idct.asm',
        'patched-ffmpeg/libavcodec/x86/h264_idct_10bit.asm',
        'patched-ffmpeg/libavcodec/x86/h264_weight.asm',
        'patched-ffmpeg/libavcodec/x86/h264_weight_10bit.asm',
        'patched-ffmpeg/libavcodec/x86/h264dsp_mmx.c',
        'patched-ffmpeg/libavcodec/x86/mpegaudiodec_mmx.c',
      ],
    }],  # (target_arch == "ia32" or target_arch == "x64") and (ffmpeg_branding == "Chrome" or ffmpeg_branding == "ChromeOS")
    ['(1) and (ffmpeg_branding == "ChromeOS")', {
      'sources': [
        'patched-ffmpeg/libavcodec/acelp_filters.c',
        'patched-ffmpeg/libavcodec/acelp_pitch_delay.c',
        'patched-ffmpeg/libavcodec/acelp_vectors.c',
        'patched-ffmpeg/libavcodec/amrnbdec.c',
        'patched-ffmpeg/libavcodec/amrwbdec.c',
        'patched-ffmpeg/libavcodec/celp_filters.c',
        'patched-ffmpeg/libavcodec/celp_math.c',
        'patched-ffmpeg/libavcodec/flvdec.c',
        'patched-ffmpeg/libavcodec/h263.c',
        'patched-ffmpeg/libavcodec/h263_parser.c',
        'patched-ffmpeg/libavcodec/h263dec.c',
        'patched-ffmpeg/libavcodec/intelh263dec.c',
        'patched-ffmpeg/libavcodec/ituh263dec.c',
        'patched-ffmpeg/libavcodec/lsp.c',
        'patched-ffmpeg/libavcodec/mpeg4video.c',
        'patched-ffmpeg/libavcodec/mpeg4video_parser.c',
        'patched-ffmpeg/libavcodec/mpeg4videodec.c',
        'patched-ffmpeg/libavformat/amr.c',
        'patched-ffmpeg/libavformat/avi.c',
        'patched-ffmpeg/libavformat/avidec.c',
      ],
    }],  # (1) and (ffmpeg_branding == "ChromeOS")
    ['(target_arch == "arm" or (target_arch == "arm" and arm_neon == 1)) and (ffmpeg_branding == "Chrome" or ffmpeg_branding == "ChromeOS")', {
      'sources': [
        'patched-ffmpeg/libavcodec/arm/h264dsp_init_arm.c',
        'patched-ffmpeg/libavcodec/arm/mpegaudiodsp_fixed_armv6.S',
        'patched-ffmpeg/libavcodec/arm/mpegaudiodsp_init_arm.c',
      ],
    }],  # (target_arch == "arm" or (target_arch == "arm" and arm_neon == 1)) and (ffmpeg_branding == "Chrome" or ffmpeg_branding == "ChromeOS")
    ['((target_arch == "arm" and arm_neon == 1)) and (1)', {
      'sources': [
        'patched-ffmpeg/libavcodec/arm/dsputil_init_neon.c',
        'patched-ffmpeg/libavcodec/arm/dsputil_neon.S',
        'patched-ffmpeg/libavcodec/arm/fft_fixed_neon.S',
        'patched-ffmpeg/libavcodec/arm/fft_neon.S',
        'patched-ffmpeg/libavcodec/arm/fmtconvert_neon.S',
        'patched-ffmpeg/libavcodec/arm/h264pred_neon.S',
        'patched-ffmpeg/libavcodec/arm/int_neon.S',
        'patched-ffmpeg/libavcodec/arm/mdct_fixed_neon.S',
        'patched-ffmpeg/libavcodec/arm/mdct_neon.S',
        'patched-ffmpeg/libavcodec/arm/mpegvideo_neon.S',
        'patched-ffmpeg/libavcodec/arm/rdft_neon.S',
        'patched-ffmpeg/libavcodec/arm/simple_idct_neon.S',
        'patched-ffmpeg/libavcodec/arm/vp3dsp_neon.S',
        'patched-ffmpeg/libavcodec/arm/vp8dsp_neon.S',
      ],
    }],  # ((target_arch == "arm" and arm_neon == 1)) and (1)
    ['(target_arch == "ia32" or target_arch == "x64") and (1)', {
      'sources': [
        'patched-ffmpeg/libavcodec/x86/deinterlace.asm',
        'patched-ffmpeg/libavcodec/x86/dsputil_mmx.c',
        'patched-ffmpeg/libavcodec/x86/dsputil_yasm.asm',
        'patched-ffmpeg/libavcodec/x86/fdct_mmx.c',
        'patched-ffmpeg/libavcodec/x86/fft.c',
        'patched-ffmpeg/libavcodec/x86/fft_mmx.asm',
        'patched-ffmpeg/libavcodec/x86/fft_sse.c',
        'patched-ffmpeg/libavcodec/x86/fmtconvert.asm',
        'patched-ffmpeg/libavcodec/x86/fmtconvert_mmx.c',
        'patched-ffmpeg/libavcodec/x86/h264_chromamc.asm',
        'patched-ffmpeg/libavcodec/x86/h264_chromamc_10bit.asm',
        'patched-ffmpeg/libavcodec/x86/h264_intrapred.asm',
        'patched-ffmpeg/libavcodec/x86/h264_intrapred_10bit.asm',
        'patched-ffmpeg/libavcodec/x86/h264_intrapred_init.c',
        'patched-ffmpeg/libavcodec/x86/h264_qpel_10bit.asm',
        'patched-ffmpeg/libavcodec/x86/idct_mmx_xvid.c',
        'patched-ffmpeg/libavcodec/x86/idct_sse2_xvid.c',
        'patched-ffmpeg/libavcodec/x86/motion_est_mmx.c',
        'patched-ffmpeg/libavcodec/x86/mpegvideo_mmx.c',
        'patched-ffmpeg/libavcodec/x86/simple_idct_mmx.c',
        'patched-ffmpeg/libavcodec/x86/vp3dsp.asm',
        'patched-ffmpeg/libavcodec/x86/vp8dsp-init.c',
        'patched-ffmpeg/libavcodec/x86/vp8dsp.asm',
        'patched-ffmpeg/libavutil/x86/cpu.c',
      ],
    }],  # (target_arch == "ia32" or target_arch == "x64") and (1)
    ['(1) and (ffmpeg_branding == "Chrome" or ffmpeg_branding == "ChromeOS")', {
      'sources': [
        'patched-ffmpeg/libavcodec/aacadtsdec.c',
        'patched-ffmpeg/libavcodec/aacdec.c',
        'patched-ffmpeg/libavcodec/aacps.c',
        'patched-ffmpeg/libavcodec/aacsbr.c',
        'patched-ffmpeg/libavcodec/aactab.c',
        'patched-ffmpeg/libavcodec/cabac.c',
        'patched-ffmpeg/libavcodec/dct.c',
        'patched-ffmpeg/libavcodec/dct32_fixed.c',
        'patched-ffmpeg/libavcodec/dct32_float.c',
        'patched-ffmpeg/libavcodec/error_resilience.c',
        'patched-ffmpeg/libavcodec/h264.c',
        'patched-ffmpeg/libavcodec/h264_cabac.c',
        'patched-ffmpeg/libavcodec/h264_cavlc.c',
        'patched-ffmpeg/libavcodec/h264_direct.c',
        'patched-ffmpeg/libavcodec/h264_loopfilter.c',
        'patched-ffmpeg/libavcodec/h264_mp4toannexb_bsf.c',
        'patched-ffmpeg/libavcodec/h264_ps.c',
        'patched-ffmpeg/libavcodec/h264_refs.c',
        'patched-ffmpeg/libavcodec/h264_sei.c',
        'patched-ffmpeg/libavcodec/h264dsp.c',
        'patched-ffmpeg/libavcodec/h264idct.c',
        'patched-ffmpeg/libavcodec/kbdwin.c',
        'patched-ffmpeg/libavcodec/mpegaudio.c',
        'patched-ffmpeg/libavcodec/mpegaudio_parser.c',
        'patched-ffmpeg/libavcodec/mpegaudiodec.c',
        'patched-ffmpeg/libavcodec/mpegaudiodecheader.c',
        'patched-ffmpeg/libavcodec/mpegaudiodsp.c',
        'patched-ffmpeg/libavcodec/mpegaudiodsp_fixed.c',
        'patched-ffmpeg/libavcodec/mpegaudiodsp_float.c',
        'patched-ffmpeg/libavcodec/mpegvideo.c',
        'patched-ffmpeg/libavcodec/sinewin.c',
        'patched-ffmpeg/libavformat/mov.c',
        'patched-ffmpeg/libavformat/mp3dec.c',
      ],
    }],  # (1) and (ffmpeg_branding == "Chrome" or ffmpeg_branding == "ChromeOS")
    ['(1) and (ffmpeg_branding == "ChromiumOS" or ffmpeg_branding == "ChromeOS")', {
      'sources': [
        'patched-ffmpeg/libavcodec/flac.c',
        'patched-ffmpeg/libavcodec/flac_parser.c',
        'patched-ffmpeg/libavcodec/flacdata.c',
        'patched-ffmpeg/libavcodec/flacdec.c',
        'patched-ffmpeg/libavformat/flacdec.c',
        'patched-ffmpeg/libavformat/oggparseflac.c',
        'patched-ffmpeg/libavformat/rawdec.c',
      ],
    }],  # (1) and (ffmpeg_branding == "ChromiumOS" or ffmpeg_branding == "ChromeOS")
    ['(target_arch == "arm" or (target_arch == "arm" and arm_neon == 1)) and (1)', {
      'sources': [
        'patched-ffmpeg/libavcodec/arm/dsputil_arm.S',
        'patched-ffmpeg/libavcodec/arm/dsputil_armv6.S',
        'patched-ffmpeg/libavcodec/arm/dsputil_init_arm.c',
        'patched-ffmpeg/libavcodec/arm/dsputil_init_armv5te.c',
        'patched-ffmpeg/libavcodec/arm/dsputil_init_armv6.c',
        'patched-ffmpeg/libavcodec/arm/dsputil_init_vfp.c',
        'patched-ffmpeg/libavcodec/arm/dsputil_vfp.S',
        'patched-ffmpeg/libavcodec/arm/fft_fixed_init_arm.c',
        'patched-ffmpeg/libavcodec/arm/fft_init_arm.c',
        'patched-ffmpeg/libavcodec/arm/fmtconvert_init_arm.c',
        'patched-ffmpeg/libavcodec/arm/fmtconvert_vfp.S',
        'patched-ffmpeg/libavcodec/arm/h264pred_init_arm.c',
        'patched-ffmpeg/libavcodec/arm/jrevdct_arm.S',
        'patched-ffmpeg/libavcodec/arm/mpegvideo_arm.c',
        'patched-ffmpeg/libavcodec/arm/mpegvideo_armv5te.c',
        'patched-ffmpeg/libavcodec/arm/mpegvideo_armv5te_s.S',
        'patched-ffmpeg/libavcodec/arm/simple_idct_arm.S',
        'patched-ffmpeg/libavcodec/arm/simple_idct_armv5te.S',
        'patched-ffmpeg/libavcodec/arm/simple_idct_armv6.S',
        'patched-ffmpeg/libavcodec/arm/vp8_armv6.S',
        'patched-ffmpeg/libavcodec/arm/vp8dsp_armv6.S',
        'patched-ffmpeg/libavcodec/arm/vp8dsp_init_arm.c',
        'patched-ffmpeg/libavutil/arm/cpu.c',
      ],
    }],  # (target_arch == "arm" or (target_arch == "arm" and arm_neon == 1)) and (1)
    ['(1) and (1)', {
      'sources': [
        'patched-ffmpeg/libavcodec/allcodecs.c',
        'patched-ffmpeg/libavcodec/audioconvert.c',
        'patched-ffmpeg/libavcodec/avfft.c',
        'patched-ffmpeg/libavcodec/avpacket.c',
        'patched-ffmpeg/libavcodec/bitstream.c',
        'patched-ffmpeg/libavcodec/bitstream_filter.c',
        'patched-ffmpeg/libavcodec/dsputil.c',
        'patched-ffmpeg/libavcodec/faanidct.c',
        'patched-ffmpeg/libavcodec/fft_fixed.c',
        'patched-ffmpeg/libavcodec/fft_float.c',
        'patched-ffmpeg/libavcodec/fmtconvert.c',
        'patched-ffmpeg/libavcodec/golomb.c',
        'patched-ffmpeg/libavcodec/h264pred.c',
        'patched-ffmpeg/libavcodec/imgconvert.c',
        'patched-ffmpeg/libavcodec/jrevdct.c',
        'patched-ffmpeg/libavcodec/mdct_fixed.c',
        'patched-ffmpeg/libavcodec/mdct_float.c',
        'patched-ffmpeg/libavcodec/mpeg12data.c',
        'patched-ffmpeg/libavcodec/mpeg4audio.c',
        'patched-ffmpeg/libavcodec/mpegaudiodata.c',
        'patched-ffmpeg/libavcodec/options.c',
        'patched-ffmpeg/libavcodec/parser.c',
        'patched-ffmpeg/libavcodec/pcm.c',
        'patched-ffmpeg/libavcodec/pthread.c',
        'patched-ffmpeg/libavcodec/raw.c',
        'patched-ffmpeg/libavcodec/rawdec.c',
        'patched-ffmpeg/libavcodec/rdft.c',
        'patched-ffmpeg/libavcodec/simple_idct.c',
        'patched-ffmpeg/libavcodec/utils.c',
        'patched-ffmpeg/libavcodec/vorbis.c',
        'patched-ffmpeg/libavcodec/vorbis_data.c',
        'patched-ffmpeg/libavcodec/vorbisdec.c',
        'patched-ffmpeg/libavcodec/vp3.c',
        'patched-ffmpeg/libavcodec/vp3dsp.c',
        'patched-ffmpeg/libavcodec/vp56rac.c',
        'patched-ffmpeg/libavcodec/vp8.c',
        'patched-ffmpeg/libavcodec/vp8_parser.c',
        'patched-ffmpeg/libavcodec/vp8dsp.c',
        'patched-ffmpeg/libavcodec/xiph.c',
        'patched-ffmpeg/libavformat/allformats.c',
        'patched-ffmpeg/libavformat/avio.c',
        'patched-ffmpeg/libavformat/aviobuf.c',
        'patched-ffmpeg/libavformat/cutils.c',
        'patched-ffmpeg/libavformat/id3v1.c',
        'patched-ffmpeg/libavformat/id3v2.c',
        'patched-ffmpeg/libavformat/isom.c',
        'patched-ffmpeg/libavformat/matroska.c',
        'patched-ffmpeg/libavformat/matroskadec.c',
        'patched-ffmpeg/libavformat/metadata.c',
        'patched-ffmpeg/libavformat/oggdec.c',
        'patched-ffmpeg/libavformat/oggparsecelt.c',
        'patched-ffmpeg/libavformat/oggparseogm.c',
        'patched-ffmpeg/libavformat/oggparseskeleton.c',
        'patched-ffmpeg/libavformat/oggparsetheora.c',
        'patched-ffmpeg/libavformat/oggparsevorbis.c',
        'patched-ffmpeg/libavformat/options.c',
        'patched-ffmpeg/libavformat/pcm.c',
        'patched-ffmpeg/libavformat/riff.c',
        'patched-ffmpeg/libavformat/rm.c',
        'patched-ffmpeg/libavformat/rmdec.c',
        'patched-ffmpeg/libavformat/seek.c',
        'patched-ffmpeg/libavformat/utils.c',
        'patched-ffmpeg/libavformat/vorbiscomment.c',
        'patched-ffmpeg/libavformat/wav.c',
        'patched-ffmpeg/libavutil/audioconvert.c',
        'patched-ffmpeg/libavutil/avstring.c',
        'patched-ffmpeg/libavutil/base64.c',
        'patched-ffmpeg/libavutil/cpu.c',
        'patched-ffmpeg/libavutil/crc.c',
        'patched-ffmpeg/libavutil/dict.c',
        'patched-ffmpeg/libavutil/eval.c',
        'patched-ffmpeg/libavutil/fifo.c',
        'patched-ffmpeg/libavutil/imgutils.c',
        'patched-ffmpeg/libavutil/intfloat_readwrite.c',
        'patched-ffmpeg/libavutil/inverse.c',
        'patched-ffmpeg/libavutil/lfg.c',
        'patched-ffmpeg/libavutil/log.c',
        'patched-ffmpeg/libavutil/lzo.c',
        'patched-ffmpeg/libavutil/mathematics.c',
        'patched-ffmpeg/libavutil/md5.c',
        'patched-ffmpeg/libavutil/mem.c',
        'patched-ffmpeg/libavutil/opt.c',
        'patched-ffmpeg/libavutil/parseutils.c',
        'patched-ffmpeg/libavutil/pixdesc.c',
        'patched-ffmpeg/libavutil/random_seed.c',
        'patched-ffmpeg/libavutil/rational.c',
        'patched-ffmpeg/libavutil/samplefmt.c',
        'patched-ffmpeg/libavutil/utils.c',
      ],
    }],  # (1) and (1)
  ],  # conditions
}
