# Copyright (c) 2011 The Chromium Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

{
  'targets': [
    {
      'target_name': 'sfntly',
      'type': 'static_library',
      'sources': [
        'src/sfntly/data/byte_array.cc',
        'src/sfntly/data/byte_array.h',
        'src/sfntly/data/font_data.cc',
        'src/sfntly/data/font_data.h',
        'src/sfntly/data/font_input_stream.cc',
        'src/sfntly/data/font_input_stream.h',
        'src/sfntly/data/font_output_stream.cc',
        'src/sfntly/data/font_output_stream.h',
        'src/sfntly/data/growable_memory_byte_array.cc',
        'src/sfntly/data/growable_memory_byte_array.h',
        'src/sfntly/data/memory_byte_array.cc',
        'src/sfntly/data/memory_byte_array.h',
        'src/sfntly/data/readable_font_data.cc',
        'src/sfntly/data/readable_font_data.h',
        'src/sfntly/data/writable_font_data.cc',
        'src/sfntly/data/writable_font_data.h',
        'src/sfntly/font.cc',
        'src/sfntly/font.h',
        'src/sfntly/font_factory.cc',
        'src/sfntly/font_factory.h',
        'src/sfntly/math/fixed1616.h',
        'src/sfntly/math/font_math.h',
        'src/sfntly/port/atomic.h',
        'src/sfntly/port/config.h',
        'src/sfntly/port/endian.h',
        'src/sfntly/port/exception_type.h',
        'src/sfntly/port/file_input_stream.cc',
        'src/sfntly/port/file_input_stream.h',
        'src/sfntly/port/input_stream.h',
        'src/sfntly/port/lock.cc',
        'src/sfntly/port/lock.h',
        'src/sfntly/port/memory_input_stream.cc',
        'src/sfntly/port/memory_input_stream.h',
        'src/sfntly/port/memory_output_stream.cc',
        'src/sfntly/port/memory_output_stream.h',
        'src/sfntly/port/output_stream.h',
        'src/sfntly/port/refcount.h',
        'src/sfntly/port/type.h',
        'src/sfntly/table/bitmap/bitmap_glyph.cc',
        'src/sfntly/table/bitmap/bitmap_glyph.h',
        'src/sfntly/table/bitmap/bitmap_size_table.cc',
        'src/sfntly/table/bitmap/bitmap_size_table.h',
        'src/sfntly/table/bitmap/composite_bitmap_glyph.cc',
        'src/sfntly/table/bitmap/composite_bitmap_glyph.h',
        'src/sfntly/table/bitmap/ebdt_table.cc',
        'src/sfntly/table/bitmap/ebdt_table.h',
        'src/sfntly/table/bitmap/eblc_table.cc',
        'src/sfntly/table/bitmap/eblc_table.h',
        'src/sfntly/table/bitmap/index_sub_table.cc',
        'src/sfntly/table/bitmap/index_sub_table.h',
        'src/sfntly/table/bitmap/index_sub_table_format1.cc',
        'src/sfntly/table/bitmap/index_sub_table_format1.h',
        'src/sfntly/table/bitmap/index_sub_table_format2.cc',
        'src/sfntly/table/bitmap/index_sub_table_format2.h',
        'src/sfntly/table/bitmap/index_sub_table_format3.cc',
        'src/sfntly/table/bitmap/index_sub_table_format3.h',
        'src/sfntly/table/bitmap/index_sub_table_format4.cc',
        'src/sfntly/table/bitmap/index_sub_table_format4.h',
        'src/sfntly/table/bitmap/index_sub_table_format5.cc',
        'src/sfntly/table/bitmap/index_sub_table_format5.h',
        'src/sfntly/table/bitmap/simple_bitmap_glyph.cc',
        'src/sfntly/table/bitmap/simple_bitmap_glyph.h',
        'src/sfntly/table/core/cmap_table.cc',
        'src/sfntly/table/core/cmap_table.h',
        'src/sfntly/table/core/font_header_table.cc',
        'src/sfntly/table/core/font_header_table.h',
        'src/sfntly/table/core/horizontal_header_table.cc',
        'src/sfntly/table/core/horizontal_header_table.h',
        'src/sfntly/table/core/horizontal_metrics_table.cc',
        'src/sfntly/table/core/horizontal_metrics_table.h',
        'src/sfntly/table/core/maximum_profile_table.cc',
        'src/sfntly/table/core/maximum_profile_table.h',
        'src/sfntly/table/core/name_table.cc',
        'src/sfntly/table/core/name_table.h',
        'src/sfntly/table/core/os2_table.cc',
        'src/sfntly/table/core/os2_table.h',
        'src/sfntly/table/font_data_table.cc',
        'src/sfntly/table/font_data_table.h',
        'src/sfntly/table/header.cc',
        'src/sfntly/table/header.h',
        'src/sfntly/table/subtable.cc',
        'src/sfntly/table/subtable.h',
        'src/sfntly/table/subtable_container_table.h',
        'src/sfntly/table/table.cc',
        'src/sfntly/table/table.h',
        'src/sfntly/table/table_based_table_builder.cc',
        'src/sfntly/table/table_based_table_builder.h',
        'src/sfntly/table/truetype/glyph_table.cc',
        'src/sfntly/table/truetype/glyph_table.h',
        'src/sfntly/table/truetype/loca_table.cc',
        'src/sfntly/table/truetype/loca_table.h',
        'src/sfntly/tag.cc',
        'src/sfntly/tag.h',
        'src/subsetter/font_subsetter.cc',
        'src/subsetter/font_subsetter.h',
        'src/subsetter/subsetter_impl.cc',
        'src/subsetter/subsetter_impl.h',
      ],
      'include_dirs': [
        'src', '../..',
      ],
      # This macro must be define to suppress the use of exception
      'defines': [
        'SFNTLY_NO_EXCEPTION',
      ],
      'dependencies' : [
        '../icu/icu.gyp:icuuc',
      ],
    },
  ]
}
